<?php
if ( ! class_exists( 'Production_Industry_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Production_Industry_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Production_Industry_Plugin_Activation_WPElemento_Importer {

        private static $production_industry_instance;
        public $production_industry_action_count;
        public $production_industry_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$production_industry_instance) ) {
            self::$production_industry_instance = new self();
          }
          return self::$production_industry_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'production_industry_recommended_plugins', array($this, 'production_industry_recommended_elemento_importer_plugins_array') );

            $production_industry_actions                   = $this->production_industry_get_recommended_actions();
            $this->production_industry_action_count        = $production_industry_actions['count'];
            $this->production_industry_recommended_actions = $production_industry_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function production_industry_recommended_elemento_importer_plugins_array($production_industry_plugins){
            $production_industry_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'production-industry'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'production-industry'),               
            );
            return $production_industry_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'production-industry-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('production-industry-plugin-activation-script', 'production_industry_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'production-industry'),
                    'activating' => esc_html__('Activating', 'production-industry'),
                    'error' => esc_html__('Error', 'production-industry'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'production-industry-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function production_industry_get_recommended_actions() {

            $production_industry_act_count  = 0;
            $production_industry_actions_todo = get_option( 'recommending_actions', array());

            $production_industry_plugins = $this->production_industry_get_recommended_plugins();

            if ($production_industry_plugins) {
                foreach ($production_industry_plugins as $production_industry_key => $production_industry_plugin) {
                    $production_industry_action = array();
                    if (!isset($production_industry_plugin['slug'])) {
                        continue;
                    }

                    $production_industry_action['id']   = 'install_' . $production_industry_plugin['slug'];
                    $production_industry_action['desc'] = '';
                    if (isset($production_industry_plugin['desc'])) {
                        $production_industry_action['desc'] = $production_industry_plugin['desc'];
                    }

                    $production_industry_action['name'] = '';
                    if (isset($production_industry_plugin['name'])) {
                        $production_industry_action['title'] = $production_industry_plugin['name'];
                    }

                    $production_industry_link_and_is_done  = $this->production_industry_get_plugin_buttion($production_industry_plugin['slug'], $production_industry_plugin['name'], $production_industry_plugin['function']);
                    $production_industry_action['link']    = $production_industry_link_and_is_done['button'];
                    $production_industry_action['is_done'] = $production_industry_link_and_is_done['done'];
                    if (!$production_industry_action['is_done'] && (!isset($production_industry_actions_todo[$production_industry_action['id']]) || !$production_industry_actions_todo[$production_industry_action['id']])) {
                        $production_industry_act_count++;
                    }
                    $production_industry_recommended_actions[] = $production_industry_action;
                    $production_industry_actions_todo[]        = array('id' => $production_industry_action['id'], 'watch' => true);
                }
                return array('count' => $production_industry_act_count, 'actions' => $production_industry_recommended_actions);
            }

        }

        public function production_industry_get_recommended_plugins() {

            $production_industry_plugins = apply_filters('production_industry_recommended_plugins', array());
            return $production_industry_plugins;
        }

        public function production_industry_get_plugin_buttion($slug, $name, $function) {
                $production_industry_is_done      = false;
                $production_industry_button_html  = '';
                $production_industry_is_installed = $this->is_plugin_installed($slug);
                $production_industry_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $production_industry_is_activeted = (class_exists($function)) ? true : false;
                if (!$production_industry_is_installed) {
                    $production_industry_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $production_industry_plugin_install_url = wp_nonce_url($production_industry_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $production_industry_button_html        = sprintf('<a class="production-industry-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($production_industry_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'production-industry'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'production-industry')
                    );
                } elseif ($production_industry_is_installed && !$production_industry_is_activeted) {

                    $production_industry_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($production_industry_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $production_industry_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $production_industry_button_html = sprintf('<a class="production-industry-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($production_industry_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'production-industry'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'production-industry')
                    );
                } elseif ($production_industry_is_activeted) {
                    $production_industry_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'production-industry'));
                    $production_industry_is_done     = true;
                }

                return array('done' => $production_industry_is_done, 'button' => $production_industry_button_html);
            }
        public function is_plugin_installed($slug) {
            $production_industry_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $production_industry_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($production_industry_installed_plugins[$production_industry_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $production_industry_keys = array_keys($this->get_installed_plugins());
            foreach ($production_industry_keys as $production_industry_key) {
                if (preg_match('|^' . $slug . '/|', $production_industry_key)) {
                    return $production_industry_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Production_Industry_Plugin_Activation_WPElemento_Importer::get_instance();